// src/simulation_widget.hh - Copyright 2005, 2006, University
//               of Padova, dept. of Pure and Applied
//               Mathematics
//
// This file is part of SGPEMv2.
//
// This is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// SGPEMv2 is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with SGPEMv2; if not, write to the Free Software
// Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA

#ifndef SIMULATION_WIDGET_HH
#define SIMULATION_WIDGET_HH 1

#include "config.h"

#include "cairo_widget.hh"
#include "backend/history_observer.hh"
#include "backend/simulation_observer.hh"

namespace sgpem
{
  class SimulationWidget : public SimulationObserver, public HistoryObserver, public  CairoWidget
  {
  public:
    SimulationWidget(Simulation& simulation);
    virtual ~SimulationWidget();
    void update(const Simulation& changed_simulation);
    void update(const History& changed_history);

  protected:
    //virtual bool on_button_press_event(GdkEventButton* event);
    // void change_scaling_mode();

    void draw_widget(cairo_t* ctx);

    virtual void calc_drawing_size(cairo_t* ctx, size_t& width, size_t& height);

  private:
    int _x_unit;
    int _y_unit;
    Simulation* _simulation;
  };

} //~ namespace sgpem


#endif //~ SIMULATION_WIDGET_HH
